#!/bin/bash -i
#clear

oldPS3=$PS3
oldS1=$PS1
TEMPLATE="T1"
NEW_PS3='Select an option and press Enter: '
PS3=$NEW_PS3
splitstr='----------------------------'
quit=0
filename='ZZ_coloredPrompt.sh'

CT=106
CS=105
CR=103
CE=127
CT2=153
CS2=154
CR2=126
CE2=127
TT=''
RQualityMin=3
RfgColor=''
RbgColor=''

MY_DIR="$(dirname $0)"
TCOL="$MY_DIR/terminal-colors.bash"


function createPS1(){
  echo -n 'PS1='
  "$TCOL" -t "$TEMPLATE" -c "$CT $CS $CR $CE $CT2 $CS2 $CR2 $CE2" -r "$TT"
}
function setPS1(){
  export PS1="$("$TCOL" -T "$TEMPLATE" -c "$CT $CS $CR $CE $CT2 $CS2 $CR2 $CE2" -r "$TT")"
}

function getAssignedColors(){
  echo -e "   Text: $("$TCOL" -S "$CT") #CT# \e[0m"
  echo -e "Symbols: $("$TCOL" -S "$CS") #CS# \e[0m"
  echo -e "   Root: $("$TCOL" -S "$CR") #CR# \e[0m"
  echo -e "  Error: $("$TCOL" -S "$CE") #CE# \e[0m"
  echo -e "   Text 2: (usually the first line)$("$TCOL" -S "$CT2") #CT2# \e[0m"
  echo -e "Symbols 2: (usually the first line)$("$TCOL" -S "$CS2") #CS2# \e[0m"
  echo -e "   Root 2: (usually the first line)$("$TCOL" -S "$CR2") #CR2# \e[0m"
  echo -e "  Error 2: (usually the first line)$("$TCOL" -S "$CE2") #CE2# \e[0m"
  echo -e "Two lines example (one line the #CT#, #CS#, #CR#, #CE# are used only): \n"
  echo -e "  $("$TCOL" -S "$CS2")#-[$("$TCOL" -S "$CR2")root$("$TCOL" -S "$CS2")]-[$("$TCOL" -S "$CE2")Exit code 127$("$TCOL" -S "$CS2")]-[$("$TCOL" -S "$CT2")$(date)$("$TCOL" -S "$CS2")]--#$("$TCOL" -S "200")"
  echo -e "  $("$TCOL" -S "$CR")root$("$TCOL" -S "$CS")@$("$TCOL" -S "$CT")machine)$("$TCOL" -S "$CS"):$("$TCOL" -S "$CT")/root $("$TCOL" -S "$CS")#$("$TCOL" -S "200") "
  
}

while [ $quit = "0" ]; do
  echo "Create colored PS1 by Igor Mega"
  echo "Licence: FOB, version: 0.1"
  echo '---------------------------------------'

  select i in "Show this menu" "Set template" "Show template" "Colors and title" "Show PS1" "Test PS1" "Set filename" "Create file" "Quit"
  do
    case $i in
      "Show this menu")
                  echo "" 
                  break
                  ;;
      "Set template")
                  echo "$splitstr"  
                  echo "Write teplate and press Enter"
                  echo "T1 - standard prompt with ~ as home"
                  echo "T2 - standard prompt with full home path"
                  echo "T3 - two lines prompt with ~ as home"
                  echo "T4 - two lines prompt with full home path"
                  echo " or write user template. Colors included as: "
                  echo '   #CT# #CS# #CR# #CE# #CT2# #CS2# #CR2# #CE2# '
                  echo -n " New template: "
                  read TEMPLATE
                  echo -e "$splitstr\nTemplate: $TEMPLATE\n$splitstr\n"
                  break
                  ;;
      "Show template")
                  echo -e "$splitstr\nTemplate: $TEMPLATE\n$splitstr\n"
                  break
                  ;;
      "Colors and title")  
                  subquit=0
                  while [ $subquit = "0" ]; do
                    echo -e "\n********* TITLE AND COLORS *********"
                    select j in "Set terminal title" "Show terminal title" "Show assigned colors" "Read quality filter" "Set foreground filter"  "Set background filter" "Display colors" "Set colors"  "Return to main menu"
                    do
                      case $j in
                        "Set terminal title")
                                 echo -e "Note: Terminal title is not changed to previous text on exit command."
                                 echo '      Empty string = no change (default)'
                                 echo 'Write new title (recomended use only [a-z,A-Z,0-9,@_-]): '
                                 read TT
                                 echo -e "$splitstr\nTerminal title: $TT\n$splitstr\n"
                                 break
                                 ;;
                        "Show terminal title")
                                 if [ -z "$TT" ]; then
                                    echo -e "\n$splitstr\nTerminal title: <empty = no change title>\n$splitstr\n"
                                 else
                                   echo -e "$splitstr\nTerminal title: $TT\n$splitstr\n"
                                 fi
                                 break
                                 ;;
                        "Show assigned colors")
                                 echo -e "\n$splitstr"
                                 getAssignedColors   
                                 echo -e "\e[0m$splitstr\n"
                                 break
                                 ;;
                        "Read quality filter")
                                 echo -e "\n0 = no readable, 4 = the best contrast, recomended min. 3 (default)"
                                 echo -n "Type 0-4 [$RQualityMin]: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   RQualityMin=$(($inputx+0))
                                   if [[ $RQualityMin -lt 0 ]]; then
                                     RQualityMin=0
                                   fi
                                   if [[ $RQualityMin -gt 4 ]]; then
                                     RQualityMin=4
                                   fi
                                 fi
                                 echo -e "$splitstr\nRead quality minimum: $RQualityMin\n$splitstr\n"
                                 break
                                 ;;
                        "Set foreground filter")
                                 echo -e "\nColor number for foreground filter (empty = no filter)." 
                                 echo -n "Valid ranges [1-81] [101-181]: "
                                 read RfgColor
                                 if [[ -e "$RbgColor" ]]; then
                                   echo -e "$splitstr\nForeground color filter: <no filter>\n$splitstr\n"
                                 else
                                   echo -e "$splitstr\nForeground color filter: $RfgColor\n$splitstr\n"
                                 fi
                                 break
                                 ;;
                        "Set background filter")
                                 echo -e "\nColor number for background filter (empty = no filter)."
                                 echo -n "Valid ranges [1-81] [101-181]: "
                                 read RbgColor
                                 if [[ -e "$RbgColor" ]]; then
                                   echo -e "$splitstr\nForeground color filter: <no filter>\n$splitstr\n"
                                 else
                                   echo -e "$splitstr\nForeground color filter: $RbgColor\n$splitstr\n"
                                 fi
                                 break
                                 ;;
                        "Display colors")
                                 echo -e "\n$splitstr"
                                 filter=''
                                 if [ -n "$RfgColor" ]; then
                                   filter="-F $RfgColor"
                                 fi
                                 if [ -n "$RbgColor" ]; then
                                   filter="$filter -B $RbgColor"
                                 fi
                                 "$TCOL" -q "$RQualityMin" $filter 
                                 echo -e "$splitstr\n"
                                 break
                                 ;;
                        "Set colors")
                                 echo -e "\n$splitstr"
                                 echo "Type color and press Enter. Empty input = no change. "
                                 echo -n -e "   Color text: #CT# $("$TCOL" -S "$CT")[${CT}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CT=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CT")[${CT}]\e[0m"
                                 echo -n -e " Color symbol: #CS# $("$TCOL" -S "$CS")[${CS}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CS=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CS")[${CS}]\e[0m"
                                 echo -n -e "   Color root: #CR# $("$TCOL" -S "$CR")[${CR}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CR=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CR")[${CR}]\e[0m"
                                 echo -n -e "  Color error: #CE# $("$TCOL" -S "$CE")[${CE}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CE=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CE")[${CE}]\e[0m"
                                 echo -n -e "     Color text 2: #CT2# $("$TCOL" -S "$CT2")[${CT2}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CT2=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CT2")[${CT2}]\e[0m"
                                 echo -n -e "     Color text 2: #CS2# $("$TCOL" -S "$CS2")[${CS2}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CS2=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CS2")[${CS2}]\e[0m"
                                 echo -n -e "     Color root 2: #CR2# $("$TCOL" -S "$CR2")[${CR2}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CR2=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CR2")[${CR2}]\e[0m"
                                 echo -n -e "    Color error 2: #CE2# $("$TCOL" -S "$CE2")[${CE2}]\e[0m: "
                                 read inputx
                                 if [[ -n "$inputx" ]]; then
                                   CE2=$(($inputx+0))
                                 fi
                                 echo -e " -->  $("$TCOL" -S "$CE2")[${CE2}]\e[0m"
                                 echo -e "$splitstr\eDisplay assigned colors:"
                                 getAssignedColors
                                 echo -e "$splitstr\e"
                                 break
                                 ;;
                        "Return to main menu")  
                                 subquit=1
                                 break
                                 ;;
                      esac
                    done
                  done
                  break
                  ;;
      "Show PS1") 
                  echo -e "\n$splitstr"
                  createPS1
                  echo -e "$splitstr\n"
                  break 
                  ;;
      "Test PS1") 
                  echo -e "\nType exit and press Enter for quit test.\n$splitstr"
                  setPS1
                  /bin/bash --noprofile --login 
                  PS1=$oldPS1
                  echo -e "$splitstr\n"
                  break
                  ;;
      "Set filename")
                  echo -e "\nFile name: '$filename'"
                  echo -n "Type the new filename (empty = no change): "
                  read outputx
                  if [[ -n "$outputx" ]]; then 
                    filename="$outputx"
                  fi
                  echo "$splitstr"
                  echo "File name: '$filename'"
                  echo -e "$splitstr\n"
                  break
                  ;;
      "Create file")
                  echo ""
                  if [[ -e "$filename" ]]; then
                    echo -e "\nWrite file '$filename'"
                    echo -n "Type uppercase  yes  and press Enter: "
                    read yes
                    if [[ "$yes" != "YES" ]]; then
                      echo "$splitstr"
                      echo "Create file canceled..." 
                      echo "$splitstr"
                    fi
                  fi
                  echo -e "\nSelect content of the file: "
                  select j in "PS1 only" "With bash test" "With bash/ksh/zsh test" "Cancel"
                  do
                    case $j in
                      "PS1 only")
                                 createPS1 > "$filename"  
                                 yes=done
                                 break 
                                 ;;
                      "With bash test")
                                 echo 'if [ -n "$BASH_VERSION" ]; then'  > "$filename"
                                 echo -n "  " >> "$filename"
                                 createPS1    >> "$filename"
                                 echo 'fi'    >> "$filename"
                                 yes=done
                                 break
                                 ;;
                      "With bash/ksh/zsh test")
                                 echo 'if [ -n "$BASH_VERSION" -o -n "$KSH_VERSION" -o -n "$ZSH_VERSION" ]; then'  > "$filename"
                                 echo -n "  " >> "$filename"
                                 createPS1    >> "$filename"
                                 echo 'fi'    >> "$filename"
                                 yes=done
                                 break
                                 ;;
                      "Cancel")  yes=no
                                 break
                                 ;;
                    esac
                  done
                  echo "$splitstr"
                  if [[ "$yes" == "done" ]]; then
                    echo "Written"
                  else
                    echo "Create file canceled..."
                  fi
                  echo -e "$splitstr\n"
                  break
                  ;;
      "Quit")     quit=1 
                  break;;
    esac
  done
done

PS1=$oldPS1
PS3=$oldPS3
echo -e "$splitstr"
createPS1
echo -e "$splitstr"
exit 0
