#!/bin/bash
#read quality normal bold
#                     5        10        15        20        25        30        35        40        45        50        55        60         
#           0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 1 3 4 5 6 7 8 9 0 1 2 3 4 
 COLOR_RQ=( ? 4 0 4 4 4 4 4 4 4 4 0 3 3 3 2 2 3 4 4 2 0 2 2 2 0 2 4 0 4 2 0 1 3 3 0 2 3 4 2 1 0 3 3 1 0 4 1 2 3 3 0 0 3 3 4 2 0 3 3 0 0 3 3 3 4 1 0 1 3 3 0 1 0 4 3 1 0 4 4 1 0 )
COLORB_RQ=( ? 4 0 4 4 4 4 4 4 4 4 0 4 4 4 4 4 4 4 4 1 0 4 4 2 2 4 4 0 2 1 0 3 2 0 3 4 3 2 2 2 0 1 1 2 3 4 1 2 4 4 0 4 4 4 4 0 1 4 4 1 0 4 4 3 3 1 3 3 0 0 0 4 0 3 2 0 0 2 2 0 0 )


#color names
COLOR_NAME=( none black red green yellow blue purple cyan white )
COLOR_NAME_SHRT=( non blk red grn yel blu pur cyn wht )
#reset color
RESETCOLOR_SEQ='\e[0m'
#foreground color set by getColorSeq()
FCOLOR_SEQ=''
#background color set by getColorSeq()
BCOLOR_SEQ=''
#color (foreground adn background) set by getColorSeq()
COLOR_SEQ=''
#bold foreground color set by getColorSeq()
FCOLORB_SEQ=''
#bold color (bold foreground adn background) set by getColorSeq()
COLORB_SEQ=''

MY_DIR="$(dirname $0)"
. "$MY_DIR/terminal-colors.templates"

COLOR_INDEX=0
function getColorByName(){
  case "$1" in
    'none')   COLOR_INDEX=0 ;;
    'black')  COLOR_INDEX=1 ;;
    'red')    COLOR_INDEX=2 ;;
    'green')  COLOR_INDEX=3 ;;
    'yellow') COLOR_INDEX=4 ;;
    'blue')   COLOR_INDEX=5 ;;
    'purple') COLOR_INDEX=6 ;;
    'cyan')   COLOR_INDEX=7 ;;
    'white')  COLOR_INDEX=8 ;;
    *)
     COLOR_INDEX="$(($OPTARG+0))"
     if [[ "$COLOR_INDEX" -lt 1 || "$COLOR_INDEX" -gt 8 ]]; then
       COLOR_INDEX=0
     fi
     ;;
  esac
}

#1 argument 1 - 8 foreground color
#2 argument 1 - 8 background color
#out: set FCOLOR_SEQ BCOLOR_SEQ FCOLORB_SEQ COLOR_SEQ COLORB_SEQ
function getColorSeq(){
  FCOLOR_SEQ=
  FCOLORB_SEQ=
  BCOLOR_SEQ=
  if [[ -n "$1" && "$1" -gt 0 && "$1" -le 8 ]]; then
    FCOLOR_SEQ='\e[0;'$((29+$1))'m'
    FCOLORB_SEQ='\e[1;'$((29+$1))'m'
  fi
  if [[ -n "$2" && "$2" -gt 0 && "$2" -le 8 ]]; then
    BCOLOR_SEQ='\e['$((39+$2))'m'
  fi
  COLOR_SEQ=${FCOLOR_SEQ}${BCOLOR_SEQ}
  COLORB_SEQ=${FCOLORB_SEQ}${BCOLOR_SEQ}
  if [[ -z "$FCOLOR_SEQ" || -z "$BCOLOR_SEQ" ]]; then
    COLOR_SEQ='\e[0m'${COLOR_SEQ}
    COLORB_SEQ='\e[0m'${COLORB_SEQ}
  fi 
}

  
COLOR_FOR_INDEX_FG=0
COLOR_FOR_INDEX_BG=0
function getColorByForIndex(){
  COLOR_FOR_INDEX_FG=0
  COLOR_FOR_INDEX_BG=0
  if [[ "$1" -lt 0 || "$1" -gt 181 ]]; then
    return
  fi
  if [[ "$1" -gt 81 && "$1" -lt 101 ]]; then
    return
  fi
  if [[ "$1" -gt 100 ]]; then
    x=$(($1-101))
  else
    x=$(($1-1))
  fi
  COLOR_FOR_INDEX_FG="$(($x%9))"
  COLOR_FOR_INDEX_BG="$(($x/9))"
}

function getColorByNumber(){
  getColorByForIndex $1
  getColorSeq "$COLOR_FOR_INDEX_FG" "$COLOR_FOR_INDEX_BG"
}

function getColorByIndex(){
  getColorByNumber $1
  if [ "$1" -gt 100 ]; then
    COLOR_FULL_SEQ=$COLORB_SEQ
  else
    COLOR_FULL_SEQ=$COLOR_SEQ
  fi  
}

#1st type of print
#2nd argument = min read quality
#3rd argument = max read quality
function printColors(){
  numbr=1
  typePrn='0'
  if [[ -n "$1" ]]; then
    typePrn="$1"
  fi
  for((j=0;j<9;j++)); do
    if [[ -n "$PAR_B" &&  "$PAR_B" -ne  "$j" ]]; then
      numbr=$(($numbr+9))
      continue
    fi
    for((i=0;i<9;i++)); do
      if [[ -n "$PAR_F" &&  "$PAR_F" -ne  "$i" ]]; then
        numbr=$(($numbr+1))
        continue
      fi
      getColorSeq $i $j
      case $typePrn in
        1) 
          if [[ "${COLOR_RQ[$numbr]}" -ge "$2" && "${COLOR_RQ[$numbr]}" -le "$3" ]]; then   
            printf "%3d.${COLOR_SEQ} N: '%14s' FC:%6s BC: %7s${RESETCOLOR_SEQ}\n" $numbr "${COLOR_SEQ}" "${COLOR_NAME[$i]}" "${COLOR_NAME[$j]}"
          fi
          ;;
        2) 
          if [[ "${COLORB_RQ[$numbr]}" -ge "$2" && "${COLORB_RQ[$numbr]}" -le "$3" ]]; then
            printf "%3d.${COLORB_SEQ} B: '%14s' FC:%6s BC: %7s${RESETCOLOR_SEQ}\n" $(($numbr+100)) "${COLORB_SEQ}" "${COLOR_NAME[$i]}" "${COLOR_NAME[$j]}"
          fi
          ;; 
        *)
          if [[ "${COLOR_RQ[$numbr]}" -ge "$2" && "${COLORB_RQ[$numbr]}" -ge "$2" && "${COLOR_RQ[$numbr]}" -le "$3" && "${COLORB_RQ[$numbr]}" -le "$3" ]]; then
            printf "%3d.${COLOR_SEQ} N:'%14s' FC:%3s BC:%3s ${RESETCOLOR_SEQ} %3d.${COLORB_SEQ} B: '%14s' FC:%3s BC:%3s ${RESETCOLOR_SEQ}\n" $numbr "${COLOR_SEQ}" "${COLOR_NAME_SHRT[$i]}" "${COLOR_NAME_SHRT[$j]}" $(($numbr+100)) "${COLORB_SEQ}" "${COLOR_NAME_SHRT[$i]}" "${COLOR_NAME_SHRT[$j]}"
          fi
          ;;
      esac
      numbr=$(($numbr+1))
    done
  done
}

#empty '' params use default
#1nd - mode, 1 = print example
#2st - template of PS1 option "T1" (default), "T2", "T3" or text
#3th - #CT# text     default: 106 
#4th - #CS# symbols  default: 105
#5th - #CR# root     default: 103 
#6th - #CE# error code default: 127
#7th - #CT2# text2     default: 153
#8th - #CS2# symbols2  default: 154
#9th - #CR2# root2     default: 126 
#10th - #CE2# error code default: 127
#11th - #TT# terminal title default <empty> \[\e]0;Welcome to ArchLinux\a
# #CLR# - \e[0m
function createPS1(){
  if [[ -n "$2" ]]; then
    if [ "${#2}" -eq 2  ]; then
      Var=$2
      if [ -n "${!Var}" ]; then
        Tx=${!Var}
      else
        Tx=$2
      fi
    else
      Tx=$2
    fi
  else
    Tx=$T1  
  fi
  CT=106
  CS=105
  CR=103
  CE=127
  CT2=153
  CS2=154
  CR2=126
  CE2=127
  TT="$PAR_R_TT"
  if [[ -n "$3" && "$3" != "-" ]]; then
    CT=$3
  fi
  if [[ -n "$4" && "$4" != "-" ]]; then
    CS=$4
  fi
  if [[ -n "$5" && "$5" != "-" ]]; then
    CR=$5
  fi
  if [[ -n "$6" && "$6" != "-" ]]; then
    CE=$6
  fi
  if [[ -n "$7" && "$7" != "-" ]]; then
    CT2=$7
  fi
  if [[ -n "$8" && "$8" != "-" ]]; then
    CS2=$8
  fi
  if [[ -n "$9" && "$9" != "-" ]]; then
    CR2=$9
  fi
  if [[ -n "${10}" && "${10}" != "-" ]]; then
    CE2=${10}
  fi
  if [[ -n "${11}" && "${11}" != "-" ]]; then
    TT=${11}
  fi
  getColorByIndex $CT
  SEQ='\['$COLOR_FULL_SEQ'\]'
  PS_OUT=${Tx//#CT#/$SEQ}
  getColorByIndex $CS
  SEQ='\['$COLOR_FULL_SEQ'\]'
  PS_OUT=${PS_OUT//#CS#/$SEQ}
  getColorByIndex $CR
  SEQ='\['$COLOR_FULL_SEQ'\]'  
  PS_OUT=${PS_OUT//#CR#/$SEQ}
  getColorByIndex $CE
  SEQ='\['$COLOR_FULL_SEQ'\]'  
  PS_OUT=${PS_OUT//#CE#/$SEQ}
  getColorByIndex $CT2
  SEQ='\['$COLOR_FULL_SEQ'\]'  
  PS_OUT=${PS_OUT//#CT2#/$SEQ}
  getColorByIndex $CS2
  SEQ='\['$COLOR_FULL_SEQ'\]'  
  PS_OUT=${PS_OUT//#CS2#/$SEQ}
  getColorByIndex $CR2
  SEQ='\['$COLOR_FULL_SEQ'\]'  
  PS_OUT=${PS_OUT//#CR2#/$SEQ}
  getColorByIndex $CE2
  SEQ='\['$COLOR_FULL_SEQ'\]'
  PS_OUT=${PS_OUT//#CE2#/$SEQ}
  if [ -n "$TT" ]; then
    TT="\[\e]0;$TT\a\]"
  fi
  PS_OUT=${PS_OUT//#TT#/$TT}
  CLR='\[\e[0m\]'
  PS_OUT=${PS_OUT//#CLR#/$CLR}
  
  case $1 in
   1)
 #    PS_OUT=${PS_OUT//\\/\\\\}
 #    PS_OUT=${PS_OUT//$/\\\$}
 #    PS_OUT=${PS_OUT//\"/\\\"}
     echo  "'$PS_OUT'"
     ;;
   2)
     echo "$PS_OUT"
     ;;
  esac
  unset Tx
  unset T1
  unset T2
  unset T3
  unset T4
}

PAR_P=12
PAR_Q=0
PAR_QQ=4
PAR_T=0
PAR_Tt='T1'
PAR_F=
PAR_B=
PAR_R_TT=''
PAR_L=''
PAR_S=''
while getopts "hp:q:Q:t:T:c:f:b:F:B:r:l:L:s:S:" opt; do
  case $opt in
    p)
      case "$OPTARG" in
        'NB') PAR_P="3"
              ;;
        'B')  PAR_P="2"
              ;;
        'N')  PAR_P="1"
              ;;
        'B-N') PAR_P="21"
               ;;
        'N-B') PAR_P="12"
               ;;
        *) echo "Bad value of -p"
           exit 1
      esac
      ;;
   q) 
      PAR_Q="$(($OPTARG+0))"
      if [[ $PAR_Q -lt 0 ]]; then
        PAR_Q=0
      fi
      if [[ $PAR_Q -gt 4 ]]; then
        PAR_Q=4
      fi
      ;;
   Q)
      PAR_QQ="$(($OPTARG+0))"
      if [[ $PAR_QQ -lt 0 ]]; then
        PAR_QQ=0
      fi
      if [[ $PAR_QQ -gt 4 ]]; then
        PAR_QQ=4
      fi
      ;;
   l) PAR_L="$(($OPTARG+0))"
      PAR_T=20
      ;;
   L) PAR_L="$(($OPTARG+0))"
      PAR_T=21
      ;;
   s) PAR_S="$(($OPTARG+0))"
      PAR_T=10
      ;;
   S)
      PAR_S="$(($OPTARG+0))"
      PAR_T=11
      ;;
   t)
     PAR_T=1
     PAR_Tt=$OPTARG
     ;;
   T)
     PAR_T=2
     PAR_Tt=$OPTARG
     ;;
   r)
     PAR_R_TT="$OPTARG"
     ;;
   c)
     PAR_C=$OPTARG
     ;;
   f)
     getColorByName "$OPTARG"
     PAR_F=$COLOR_INDEX
     ;;
   b)
     getColorByName "$OPTARG"
     PAR_B=$COLOR_INDEX
     ;;
   F)
     getColorByForIndex "$OPTARG"
     if [[ "$COLOR_FOR_INDEX_FG" -lt 1 ]]; then
       echo "Bad -F value valid ranges [1-64] [10-164]"
     fi
     PAR_F=$COLOR_FOR_INDEX_FG
     ;;
   B)
     getColorByForIndex "$OPTARG"
     if [[ "$COLOR_FOR_INDEX_BG" -lt 1 ]]; then
       echo "Bad -F value valid ranges [1-64] [10-164]"
     fi
     PAR_B=$COLOR_FOR_INDEX_BG
     ;;
   h)
     echo 'Print colors and combinations, or create PS1 variable'
     echo ' By Igor Mega, License: FOB'
     echo 'Note: Read quality: on almost all black terminal, console and putty'
     echo ' Read quality:'
     echo '      0 = is not possible to read or somewhere is not possible to read'
     echo '      1 = somewhere is very difficult to read'
     echo '      2 = is possible to read (good with RGB: 0|255 0|255 0|255 colors)'
     echo '      3 = readable - recommended minimum quality'
     echo '      4 = the best to read'
     echo ' -p <type> - type: N = normal,'
     echo '                   B = bold,'
     echo '                   NB = both - beside -q,-Q,-w,-W is applied to the entire line'
     echo "                         it's filtered by read quality both typeface bold and normal"
     echo '                   N-B, B-N = both - stacked (N-B is default)'
     echo ' -q 0-4 min. read quality,  0 = print all, 4 = read only the bast readable'
     echo ' -Q 0-4 max. read quality,  0 = print all, 4 = read only the bast readable'
     echo ' -f <number> index of color, show only same foreground colors'
     echo ' -b <number> index of color, show only same background colors'
     echo '     colors value: none black, red, green, yellow, blue, purple, cyan, white'
     echo '     or as number:   0    1     2     3       4      5     6       7     8'
     echo ' -F <number> same foreground as a <number> [1-81] [101-181] normal or bold'
     echo ' -B <number> same background as a <number> [1-81] [101-181]'
     echo '-------------------------------'
     echo ' -l <number> show <number> color only'
     echo ' -L <number> show <number> color only, without new lines'
     echo ' -s <number> show <number> color sequence (200 = clear sequence)'
     echo ' -S <number> show <number> color sequence (200 = clear sequence)'
     echo '                             without quotes and new lines'
     echo ' ------------------------------'
     echo ' -t <template> - print prompt PS1 mode'
     echo '                 "T1" - basic, home dir as ~'
     echo '                 "T2" - basic, home dir as full path'
     echo '                 "T3" - two lines, home dir as ~'
     echo '                 "T4" - two lines, home dir as full path'
     echo '                 T5..T9 user defined in file terminal-colors.templates'
     echo '                 Variable to use in template: '
     echo '                   #CT#,#CS#,#CR#,#CE#,#CT2#,#CS2#,#CR2#,#CE2#'
     echo '                   #TT# - means terminal title'
     echo '  -T same as -t without new line and quotes and slashes - for script'
     echo '  -c  1-6 color numbers space separated, use - for default:' 
     echo '           Colors are: text symbol root error text2 symbol2 root2 error2'
     echo '        7th param = terminal title, it overwrites -r'
     echo '  -r <text> terminal title text, if empty no change terminal title'
     echo '                     #TT# - recommended use [a-z,A-Z,0-9]'
     echo 'Examples:'
     echo '  Show all colors without specify background: '
     echo '          ./testcolor.bash -p NB -b none'
     echo '  Show all colors with minimal read quality 3: '
     echo '          ./testcolor.bash -q 3'
     echo '  Show all colors with minimal read quality 3 bold only: '
     echo '          ./testcolor.bash -p B -q 3'
     echo '  Show all colors with minimal read quality 4 bold AND normal: '
     echo '          ./testcolor.bash -p NB -q 4'
     exit 0
     ;;
  \?)
     echo "Invalid option: -$OPTARG" >&2
     exit 1
     ;;
   :)
     echo "Option -$OPTARG requires an argument." >&2
     exit 1
     ;;
  esac
done

case $PAR_T in
  1|2)
    createPS1 $PAR_T "$PAR_Tt" $PAR_C
    ;;
  10|11)
    if [[ "$PAR_T" -eq "200" ]]; then
      COLOR_FULL_SEQ='\e[0m'
    else
      getColorByIndex "$PAR_S"
    fi
    if [[ "$PAR_T" -eq "11" ]]; then
      echo -n  "$COLOR_FULL_SEQ"
    else
      echo "'$COLOR_FULL_SEQ'"
    fi
    ;;
  20|21)
    getColorByIndex "$PAR_L" 
    if [[ "$PAR_L" -lt 10 ]]; then
      PAR_L="  $PAR_L"
    else
      if [[ "$PAR_L" -lt 100 ]]; then
        PAR_L=" $PAR_L"
      fi
    fi
    if [[ "$PAR_T" -eq "21" ]]; then
      echo  -n -e "${COLOR_FULL_SEQ}${PAR_L}\e[0m"
    else
      echo -e "${COLOR_FULL_SEQ}${PAR_L}\e[0m" 
    fi

    ;;
  *)
    if [[ "$PAR_P" -eq 12 ]]; then
      printColors "1" $PAR_Q $PAR_QQ
      printColors "2" $PAR_Q $PAR_QQ 
    else
      if [[ "$PAR_P" -eq 21 ]]; then
        printColors "2" $PAR_Q $PAR_QQ
        printColors "1" $PAR_Q $PAR_QQ
      else
        printColors "$PAR_P" $PAR_Q $PAR_QQ 
      fi
    fi
    ;;
esac

exit 0
